#include "FinalApplication.hpp"

IMPLEMENT_MAIN(FinalApplication)

FinalApplication::FinalApplication()
: titre("INFOSV PONG", getAppFont(), 150), 
top(10), bottom(580)
{

}
void FinalApplication::onInit(int, char**)
{
	titre.setFont(getAppFont());
	titre.setRotation(45);
    titre.setFillColor(sf::Color(255,255,255,50));
    titre.setPosition(100,-90);
    titre.setStyle(sf::Text::Bold);
    
	scores.push_back(Score(750,0,getAppFont()));
	scores.push_back(Score(10,540,getAppFont()));
}

void FinalApplication::onEvent(sf::Event event, sf::RenderWindow& window)
{
	if (event.type == sf::Event::Closed)
	{
			window.close();
	}
	//Déplacement souris->déplacement paddle supérieur
	else if (event.type == sf::Event::MouseMoved)
	{
		top.updatePosition(event.mouseMove.x);
	}
	//Touches directionnelles->déplacement paddle inférieur
	else if (event.type == sf::Event::KeyPressed)
	{
		if (event.key.code==sf::Keyboard::Left) bottom.updatePositionDelta(-5);
		else if (event.key.code==sf::Keyboard::Right) bottom.updatePositionDelta(5);
	}
}

void FinalApplication::onUpdate(sf::Time dt)
{
	ball.move();
	//Collision balle-paddles
	if (top.getBoundingBox().intersects(ball.getBoundingBox()) || bottom.getBoundingBox().intersects(ball.getBoundingBox()))
	{
		ball.paddleBounce();
	}
	//Game over
	int out(ball.out());
	if (out>=0)
	{
		scores[out].increment();
		ball.restart();
	}
}
void FinalApplication::onDraw(sf::RenderTarget& target)
{
	target.clear(sf::Color(214,214,214));
	//Titre
    target.draw(titre);
	//Scores
    for (int i(0); i<2; i++) scores[i].draw(target);
	//Paddles
    top.draw(target);
    bottom.draw(target);
	//Balle
    ball.draw(target);
}

